#include <time.h>
#include <sys/timeb.h>
#include <stdlib.h>
#include <windows.h>
#include <winsock2.h>

#include "gobbler.h"

int MTU1;

int usleep (unsigned usec)
{
  Sleep (usec/1000);
  return (0);
}

int nanosleep (unsigned nsec)
{
  Sleep (nsec/1000000UL);
  return (0);
}

int getuid (void)
{
  return (0);
}

int geteuid (void)
{
  return (0);
}

int pause (void)
{
  return (-1);
}

void bcopy (const void *src, void *dst, size_t len)
{
  if (len)
     memcpy (dst, src, len);
}

int inet_aton (const char *name, struct in_addr *adr)
{
  u_long ip = inet_addr (name);

  if (ip == INADDR_NONE)
     return (0);
  adr->s_addr = ip;
  return (1);
}

#ifndef HAVE_GETTIMEOFDAY      /* MingW 3.13 or later */
struct timezone {
       int tz_minuteswest;    /* minutes west of Greenwich */
       int tz_dsttime;        /* type of dst correction */
     };

int gettimeofday (struct timeval *tv, struct timezone *tz)
{
  struct _timeb tb;

  if (!tv)
    return (-1);

  _ftime (&tb);
  tv->tv_sec = tb.time;
  tv->tv_usec = tb.millitm * 1000 + 500;
  if (tz)
  {
    tz->tz_minuteswest = -60 * _timezone;
    tz->tz_dsttime = _daylight;
  }
  return (0);
}
#endif

static pcap_t *pc = NULL;

static close_interface (void)
{
  if (pc)
     pcap_close (pc);
  pc = NULL;
}

pcap_t *open_interface (void)
{
  char err[PCAP_ERRBUF_SIZE];

  pc = pcap_open_live (device, 1514, 1, 500, err);
  if (!pc)
  {
    fprintf (stderr, "pcap error: %s\n", err);
    exit (-1);
  }
  atexit (close_interface);
  return (pc);
}
